


/*
 Based on Ken's Build Engine Source Code
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <dos.h>

unsigned long *videomem = (unsigned long*)0xA0000L;

typedef struct
{
        char VESASignature[4];
        short VESAVersion;
        long OemStringPtr, Capabilities, VideoModePtr;
        short TotalMemory, OemSoftwareRev;
        long OemVendorNamePtr, OemProductNamePtr, OemProductRevPtr;
        char reserved[222], OemDATA[256];
} VBE_vgaInfo;

typedef struct
{
        short ModeAttributes;
        char WinAAtributes, WinBAttributes;
        short WinGranularity, WinSize, WinASegment, WinBSegment;
        long WinFuncPtr;
        short BytesPerScanLine, XResolution, YResolution;
        char XCharSize, YCharSize, NumberOfPlanes, BitsPerPixel;
        char NumberOfBanks, MemoryModel, BankSize, NumberOfImagePages;
        char res1;
        char RedMaskSize, RedFieldPosition;
        char GreenMaskSize, GreenFieldPosition;
        char BlueMaskSize, BlueFieldPosition;
        char RsvdMaskSize, RsvdFieldPosition, DirectColorModeInfo;
        long PhysBasePtr, OffScreenMemOffset;
        short OffScreenMemSize;
        char res2[206];
} VBE_modeInfo;

struct _RMWORDREGS { unsigned short ax, bx, cx, dx, si, di, cflag; };
struct _RMBYTEREGS { unsigned char al, ah, bl, bh, cl, ch, dl, dh; };
typedef union { struct _RMWORDREGS x; struct _RMBYTEREGS h; } RMREGS;
typedef struct { unsigned short es, cs, ss, ds; } RMSREGS;

typedef struct
{
        long edi, esi, ebp, reserved, ebx, edx, ecx, eax;
        short flags, es, ds, fs, gs, ip, cs, sp, ss;
} _RMREGS;

long VESABuf_sel = 0, VESABuf_rseg;
static VBE_vgaInfo vgaInfo;
short vesamode,lfb;
static long backlinaddress = 0;  //Save address for free operation (0x801)
long globlinplace;

long setactiveentry = 0, setvisualentry = 0, setpaletteentry = 0;

void (*FlipPages)(void);
int activepage;

unsigned short *Videobuf;


#pragma aux vesasetactive =\
        "call dword ptr [setactiveentry]",\
        parm [eax][ebx][ecx][edx]\

#pragma aux vesasetvisual =\
        "call dword ptr [setvisualentry]",\
        parm [eax][ebx][ecx][edx]\

#pragma aux vesasetpalette =\
        "call dword ptr [setpaletteentry]",\
        parm [eax][ebx][ecx][edx][esi][edi]\

        
short ods, oes, oss;
#pragma aux backupsegs =\
        "mov ods, ds",\
        "mov oes, es",\
        "mov oss, ss",\
        modify [eax]\

#pragma aux restoresegs =\
        "mov ds, ods",\
        "mov es, oes",\
        "mov ss, oss",\
        modify [eax]\

long DPMI_int86(long intno, RMREGS *in, RMREGS *out)
{
        _RMREGS rmregs;
        union REGS r;
        struct SREGS sr;

        memset(&rmregs,0,sizeof(rmregs));
        rmregs.eax = in->x.ax; rmregs.ebx = in->x.bx;
        rmregs.ecx = in->x.cx; rmregs.edx = in->x.dx;
        rmregs.esi = in->x.si; rmregs.edi = in->x.di;

        segread(&sr);
        r.w.ax = 0x300; r.h.bl = intno; r.h.bh = 0; r.w.cx = 0; sr.es = sr.ds;
        r.x.edi = (unsigned)&rmregs;
        backupsegs(); int386x(0x31,&r,&r,&sr); restoresegs();

        out->x.ax = rmregs.eax; out->x.bx = rmregs.ebx;
        out->x.cx = rmregs.ecx; out->x.dx = rmregs.edx;
        out->x.si = rmregs.esi; out->x.di = rmregs.edi;
        out->x.cflag = rmregs.flags&1;
        return(out->x.ax);
}

long DPMI_int86x(long intno, RMREGS *in, RMREGS *out, RMSREGS *sregs)
{
        _RMREGS rmregs;
        union REGS r;
        struct SREGS sr;

        memset(&rmregs, 0, sizeof(rmregs));
        rmregs.eax = in->x.ax; rmregs.ebx = in->x.bx;
        rmregs.ecx = in->x.cx; rmregs.edx = in->x.dx;
        rmregs.esi = in->x.si; rmregs.edi = in->x.di;
        rmregs.es = sregs->es;
        rmregs.ds = sregs->ds;

        segread(&sr);
        r.w.ax = 0x300; r.h.bl = intno; r.h.bh = 0; r.w.cx = 0; sr.es = sr.ds;
        r.x.edi = (unsigned)&rmregs;
        backupsegs(); int386x(0x31,&r,&r,&sr); restoresegs();

        out->x.ax = rmregs.eax; out->x.bx = rmregs.ebx;
        out->x.cx = rmregs.ecx; out->x.dx = rmregs.edx;
        out->x.si = rmregs.esi; out->x.di = rmregs.edi;
        sregs->es = rmregs.es; sregs->cs = rmregs.cs;
        sregs->ss = rmregs.ss; sregs->ds = rmregs.ds;
        out->x.cflag = rmregs.flags&1;
        return(out->x.ax);
}

static void ExitVBEBuf(void)
{
        union REGS r;
        r.w.ax = 0x101; r.w.dx = VESABuf_sel; //DPMI free real seg
        backupsegs(); int386(0x31,&r,&r); restoresegs();
}

void VBE_callESDI(RMREGS *regs, void *buffer, long size)
{
        RMSREGS sregs;
        union REGS r;

        if (!VESABuf_sel)  //Init Real mode buffer
        {
                r.w.ax = 0x100; r.w.bx = 1024>>4;
                backupsegs(); int386(0x31,&r,&r); restoresegs();
                if (r.w.cflag) { printf("DPMI_allocRealSeg failed!\n"); exit(0); }
                VESABuf_sel = r.w.dx;
                VESABuf_rseg = r.w.ax;
                atexit(ExitVBEBuf);
        }
        sregs.es = VESABuf_rseg;
        regs->x.di = 0;
        _fmemcpy(MK_FP(VESABuf_sel,0),buffer,size);
        DPMI_int86x(0x10,regs,regs,&sregs);
        _fmemcpy(buffer,MK_FP(VESABuf_sel,0),size);
}

long VBE_getModeInfo(long mode, VBE_modeInfo *modeInfo)
{
        RMREGS regs;

        regs.x.ax = 0x4f01;
        regs.x.cx = mode;
        VBE_callESDI(&regs, modeInfo, sizeof(VBE_modeInfo));
        if (regs.x.ax != 0x004f) return(0);
        if ((modeInfo->ModeAttributes&1) == 0) return(0); //1 is vbeMdAvailable
        return(1);
}

void GetPtrToLFB(long physAddr)
{
        #define LIMIT (4096*1024)-1
        long sel;
        union REGS r;

        r.w.ax = 0; r.w.cx = 1;
        backupsegs(); int386(0x31,&r,&r); restoresegs();
        if (r.x.cflag) { printf("DPMI_allocSelector() failed!\n"); exit(0); }
        sel = r.w.ax;
        r.w.ax = 9; r.w.bx = sel; r.w.cx = 0x8092;
        backupsegs(); int386(0x31,&r,&r); restoresegs();

        r.w.ax = 0x800; r.w.bx = physAddr >> 16; r.w.cx = physAddr & 0xffff;
        r.w.si = LIMIT>>16; r.w.di = LIMIT&0xffff;
        backupsegs(); int386(0x31,&r,&r); restoresegs();
        if (r.x.cflag) { printf("DPMI_mapPhysicalToLinear() failed!\n"); exit(0); }
        backlinaddress = globlinplace = ((long)r.w.bx<<16)+r.w.cx;

        r.w.ax = 7; r.w.bx = sel;
        r.w.cx = globlinplace>>16; r.w.dx = globlinplace&0xffff;
        backupsegs(); int386(0x31,&r,&r); restoresegs();
        if (r.x.cflag) { printf("DPMI_setSelectorBase() failed!\n"); exit(0); }

        r.w.ax = 8; r.w.bx = sel;
        r.w.cx = LIMIT>>16; r.w.dx = LIMIT&0xffff;
        backupsegs(); int386(0x31,&r,&r); restoresegs();
        if (r.x.cflag) { printf("DPMI_setSelectorLimit() failed!\n"); exit(0); }
}



void setbank(unsigned short banknumber)
  {
      __asm
        {
            mov ax,0x4F05
            xor ebx,ebx
            mov dx,banknumber
            int 0x10
        }
  }

void setscreenstart(unsigned short x,unsigned short y)
  {
      __asm
        {
            mov ax,0x4F07
            xor bx,bx
            mov cx,x
            mov dx,y
            int 0x10
        }
  }

void draw_buffer_bank(void)
  {
      unsigned short i;
      unsigned long bufofs;
      
      if (activepage==0)
        {
            bufofs=0;
            for(i=0;i<9;i++)
               {
                   //setactiveentry(0x4F05,0L,0L,i);
                   setbank(i);
                   __asm
                     {
                         push esi
                         push edi
                         mov esi,Videobuf
                         add esi,bufofs
                         mov edi,0xA0000
                         mov ecx,16384
                         cld
                         rep movsd
                         pop edi
                         pop esi
                     }
                   bufofs+=65536;
               }
           //setactiveentry(0x4F05,0,0,18);
           setbank(9);
           __asm
             {
                 push esi
                 push edi
                 mov esi,Videobuf
                 add esi,bufofs
                 mov edi,0xA0000
                 mov ecx,6144
                 cld
                 rep movsd
                 pop edi
                 pop esi
              }
           //setvisualentry(0x4F07,0,0,0);
           setscreenstart(0,0);
           activepage=1;
        }
      else
        {
            bufofs=0;
            //setactiveentry(0x4F05,0,0,18);
            setbank(9);
            __asm
               {
                   push esi
                   push edi
                   mov esi,Videobuf
                   mov edi,0xA0000
                   add edi,24576
                   mov ecx,10240
                   cld
                   rep movsd
                   pop edi
                   pop esi
               }
            bufofs+=40960;
            for(i=10;i<18;i++)
               {
                   //setactiveentry(0x4F05,0,0,i);
                   setbank(i);
                   __asm
                     {
                         push esi
                         push edi
                         mov esi,Videobuf
                         add esi,bufofs
                         mov edi,0xA0000
                         mov ecx,16384
                         cld
                         rep movsd
                         pop edi
                         pop esi
                     }
                   bufofs+=65536;
               }
            setbank(18);
            __asm
             {
                 push esi
                 push edi
                 mov esi,Videobuf
                 add esi,bufofs
                 mov edi,0xA0000
                 mov ecx,12288//6144
                 cld
                 rep movsd
                 pop edi
                 pop esi
              }
           setscreenstart(0,480);
           //setvisualentry(0x4F07,0,0,480);
           activepage=0;
        }
  }

void draw_buffer_lfb(void)
  {
      unsigned long *p;

      if (activepage==0)
      {
      __asm
        {
            push esi
            push edi
            mov esi,Videobuf
            mov edi,backlinaddress
            mov ecx,153600
            cld
            rep movsd
            pop edi
            pop esi
        }
        setscreenstart(0,0);
      }
      else
      {
      __asm
        {
            push esi
            push edi
            mov esi,Videobuf
            mov edi,backlinaddress
            add edi,614400
            mov ecx,153600
            cld
            rep movsd
            pop edi
            pop esi
        }
      setscreenstart(0,480);
      }
     //vesasetvisual(0x4f07,0L,0L,480);
    
  }


long init_svga640x480x16(void)
  {
    RMREGS regs;
    RMSREGS sregs;
    long i;
    short *p, *p1, *p2;
    
    /*getvalidvesa640x480x32();
    if (!vesamode)
      {
          printf("%s %d %s","mode not found (",vesamode,")");
          return;
      }*/
    vesamode=0x111;
    lfb=0;
    if (lfb)
      {
          FlipPages=draw_buffer_lfb;
          regs.x.bx=vesamode | 0x4000;
      }
    else
      {
          FlipPages=draw_buffer_bank;
          regs.x.bx=vesamode & 0xBFFF;
      }
      
    regs.x.ax=0x4F02;
    
    DPMI_int86(0x10,&regs,&regs);
    regs.x.ax=0x4F06;//virtual screen
    regs.x.bx=0;
    regs.x.cx=640;
    DPMI_int86(0x10,&regs,&regs);

                regs.x.ax = 0x4f0a; regs.x.bx = 0;
                DPMI_int86x(0x10,&regs,&regs,&sregs);
                if (regs.x.ax == 0x004f)   //cx is length of protected mode code
                {
                        i = (((long)sregs.es)<<4)+((long)regs.x.di);
                        p1 = (short *)i;
                        setactiveentry = ((long)p1[0]) + i;
                        setvisualentry = ((long)p1[1]) + i;
                        setpaletteentry = ((long)p1[2]) + i;
                                //p1[2] is useless palette function - see vesprot.asm for code
                }
  }




